/*
package problems.face.solutions;

import ac.essex.ooechs.adaboost.AdaBoostSolution;
import ac.essex.ooechs.adaboost.AdaBoostLearner;
import ac.essex.ooechs.adaboost.AdaBoostSample;
import ac.essex.ooechs.imaging.commons.HaarRegions;
import ac.essex.ooechs.imaging.commons.evolved.FaceDetector;
import ac.essex.ooechs.imaging.commons.apps.shapes.SegmentedShape;
import problems.jasmine.ShapeIndividual;import ga.classification.BinaryClassifier;
public class Solution1 extends FaceDetector {

AdaBoostSolution tester;

public Solution1() {
tester = new AdaBoostSolution(30);
tester.addHypothesis(new WeakLearner0(), 0.16440422322775325);tester.addHypothesis(new WeakLearner1(), 0.18549929973568613);tester.addHypothesis(new WeakLearner2(), 0.34661801492364);tester.addHypothesis(new WeakLearner3(), 0.3461342516155922);tester.addHypothesis(new WeakLearner4(), 0.34554310610022626);tester.addHypothesis(new WeakLearner5(), 0.474554830043815);tester.addHypothesis(new WeakLearner6(), 0.42771214640712285);tester.addHypothesis(new WeakLearner7(), 0.7035271461579845);tester.addHypothesis(new WeakLearner8(), 0.5238958467760351);tester.addHypothesis(new WeakLearner9(), 0.5478755742171991);tester.addHypothesis(new WeakLearner10(), 0.5953244875135161);tester.addHypothesis(new WeakLearner11(), 0.5722863214529309);tester.addHypothesis(new WeakLearner12(), 0.555690938757019);tester.addHypothesis(new WeakLearner13(), 0.621632707078807);tester.addHypothesis(new WeakLearner14(), 0.7032236162555837);tester.addHypothesis(new WeakLearner15(), 0.5630185669777037);tester.addHypothesis(new WeakLearner16(), 0.6268920256790668);tester.addHypothesis(new WeakLearner17(), 0.6559425784185212);tester.addHypothesis(new WeakLearner18(), 0.6089760312856801);tester.addHypothesis(new WeakLearner19(), 0.7603610932523689);tester.addHypothesis(new WeakLearner20(), 0.793242566584598);tester.addHypothesis(new WeakLearner21(), 0.6816883362747247);tester.addHypothesis(new WeakLearner22(), 0.637390624808882);tester.addHypothesis(new WeakLearner23(), 0.6445889433812075);tester.addHypothesis(new WeakLearner24(), 0.8104410823852083);tester.addHypothesis(new WeakLearner25(), 0.7275788670126777);tester.addHypothesis(new WeakLearner26(), 0.57481294602943);tester.addHypothesis(new WeakLearner27(), 0.6615344952282838);tester.addHypothesis(new WeakLearner28(), 0.8491083535299919);tester.addHypothesis(new WeakLearner29(), 0.6116902614781191);}

class WeakLearner0 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(10,7, 3, 2, 2, 2)) > 22.693278831563877? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner1 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(6,0, 4, 2, 2, 2)) > 18.73712004665356? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner2 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(5,5, 2, 1, 2, 2)) < -12.374869162640902? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner3 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(0,1, 3, 5, 1, 1)) < -19.471604798851192? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner4 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(8,7, 1, 3, 1, 2)) < -12.595011391810901? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner5 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getThreeRectangleFeature(12,1, 5, 2, 1)) < 92.08382763103786? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner6 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(4,8, 1, 1, 2, 1)) < -16.497408348495302? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner7 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(11,8, 3, 1, 1, 2)) > 3.317108048509014? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner8 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(4,5, 3, 2, 1, 2)) > 8.330647907066995? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner9 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(7,11, 2, 2, 2)) > 2.0137061827732117? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner10 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(6,10, 4, 4, 1, 2)) > 1.508162554199692? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner11 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(2,7, 2, 2, 1, 2)) < -4.248717397403992? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner12 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getThreeRectangleFeature(0,2, 5, 2, 1)) < 93.16048763166533? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner13 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(5,1, 4, 2, 2)) < -0.44428875103693943? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner14 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(6,8, 1, 6, 1, 1)) < -4.216412747209845? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner15 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(6,10, 4, 4, 2)) < -3.4494702895065212? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner16 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(4,9, 3, 1, 2, 1)) < -11.150479954827787? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner17 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(11,11, 2, 2, 1)) < -3.193396721702881? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner18 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(6,12, 4, 2, 2, 1)) > 4.2456237016472524? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner19 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(7,0, 1, 2, 1, 1)) < 0.02395465176262279? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner20 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(4,4, 2, 6, 1, 1)) < -9.04239089770492? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner21 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(12,7, 5, 2, 1)) < -1.4985758551700588? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner22 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(6,2, 4, 1, 1)) > 0.05690318471115574? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner23 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(8,6, 2, 1, 2, 1)) > 8.195741141574475? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner24 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(6,10, 1, 3, 1, 1)) < -1.955157277862593? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner25 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(10,12, 1, 1, 2)) < -2.053010697032436? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner26 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(6,6, 1, 1, 1)) < -5.55452724275188? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner27 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getTwoRectangleFeature(12,7, 1, 3, 1, 2)) > 3.3274825259728646? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner28 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(8,6, 2, 2, 1)) < -0.6405342024454342? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

class WeakLearner29 extends AdaBoostLearner {
public int classify(AdaBoostSample sample, Object data) {
	HaarRegions image = (HaarRegions) sample.getData();
	return (image.getFourRectangleFeature(11,0, 1, 3, 1)) > 0.8577444853411039? BinaryClassifier.TRUE : BinaryClassifier.FALSE;
}
}

public double calculate(HaarRegions haarRegions) {
return tester.classify(new AdaBoostSample(haarRegions)) == BinaryClassifier.TRUE? 1 : ObjectClass.NO_CLASS;
}
}*/
